import pyglet
import pymunk as pm
from pyglet.window import key
from pyglet.gl import *
from pymunk.vec2d import Vec2d

class Button(pyglet.text.Label):
    def __init__(self,text,batch,window,*args,**kwargs):
        pyglet.text.Label.__init__(self,text, *args, **kwargs)
        self.font_name = "Verdana"
        self.batch = batch
        self.window = window
        self.hover = False
        self.clicked = False
        self.font_size = 20
        self.anchor_y = "top"
        self.color = (0,0,0,255)
        self.width = self.content_width
        self.height = self.content_height
    
    def update(self,dt):
        self.hover = False
        if self.collide(self.window.mpos):
            self.hover = True
            
        if self.hover:
            self.color = (100,100,100,255)
        else:
            self.color = (0,0,0,255)
       
            
    def on_mouse_press(self, x, y, button, modifiers):
        if self.hover:
            self.clicked = True
        else:
            self.clicked = False
    
    def collide(self, other):
        if other.x >= self.x \
        and other.x <= self.x + self.width \
        and other.y >= self.y - self.height \
        and other.y <= self.y:
            return True